import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkSite, ThinkSiteParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkSite(params: ThinkSiteParam) {
  const res = await request.get<ApiResult<PageResult<ThinkSite>>>(
    THINK_API_URL + '/think/think-site/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkSite(params?: ThinkSiteParam) {
  const res = await request.get<ApiResult<ThinkSite[]>>(
    THINK_API_URL + '/think/think-site',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkSite(data: ThinkSite) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-site',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkSite(data: ThinkSite) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-site',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkSite(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-site/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkSite(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-site/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkSite(id: number) {
  const res = await request.get<ApiResult<ThinkSite>>(
    THINK_API_URL + '/think/think-site/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
